/****************************************************
 * Name: DC Motor
 * Function: the motor rotates clockwise 1s and counterclockwise 1s
 *****************************************************/
//Post technical questions on our FORUM. 
//Website: www.sunfounder.com

#define PWM1 6 //pwm1 connects to pin6
#define PWM2 5 //pwm2 connects to pin5
#define DIR1 7 //dir1  connects to pin7
#define DIR2 4 //dir2 connects to pin4

void setup() 
{
  //set all the pins as OUTPUT
  pinMode(PWM1, OUTPUT);
  pinMode(PWM2, OUTPUT);
  pinMode(DIR1, OUTPUT);
  pinMode(DIR2, OUTPUT);
}

void loop() {
  //1 represents the motor connected to out1 and out2
  //2 means the motor connected to out4 and out3
  ctlDCMotor(1, 255);
  ctlDCMotor(2, 255);
  delay(1000);//delay 1s
  ctlDCMotor(1, -255);
  ctlDCMotor(2, -255);
  delay(1000);//delay 1s
}
//set the rotational direction of motors
void ctlDCMotor(byte MotorID, int speeds)
{
  //motor1 rotation
  if (MotorID == 1) 
  {
    if (speeds > 0)
    {
      digitalWrite(DIR1, HIGH);
    }
    else
    {
      digitalWrite(DIR1, LOW);
    }
    if (abs(speeds) > 255)
    {
      speeds = 255;
    }
    analogWrite(PWM1, abs(speeds));
    //Serial.print("...........................................................left:");
    //Serial.println(abs(speeds));
  }
  //motor2 rotation
  else if (MotorID == 2)
  {
    if (speeds > 0)
    {
      digitalWrite(DIR2, HIGH);
    }
    else
    {
      digitalWrite(DIR2, LOW);
    }
    if (abs(speeds) > 255)
    {
      speeds = 255;
    }
    analogWrite(PWM2, abs(speeds));
    //Serial.print("...........................................................right:");
    //Serial.println(abs(speeds));
  }
}

