/*******************************************************
 * Name: Motor Driver Shield
 * Function: the motors,stepper motors and servos rotate
 **************************************************/
//Post technical questions on our FORUM. 
//Website: www.sunfounder.com
/****************************************************/
#include <Servo.h>

Servo myservo[2][2];//create a servo object to control a servo
#define PWM1 6
#define PWM2 5
#define DIR1 7
#define DIR2 4

int pwm;
const int servo_pin[2][2]={ 
  8, 9, 10, 11 };

const char tab1[] =
{
  0x01, 0x03, 0x02, 0x06, 0x04, 0x0c, 0x08, 0x09
};
const char tab2[] =
{
  0x01, 0x09, 0x08, 0x0c, 0x04, 0x06, 0x02, 0x03
};

void setup() {
  // put your setup code here, to run once
  {
    pinMode(A0, OUTPUT);
    pinMode(A1, OUTPUT);
    pinMode(A2, OUTPUT);
    pinMode(A3, OUTPUT);
  }
  {
    pinMode(PWM1, OUTPUT);
    pinMode(PWM2, OUTPUT);
    pinMode(DIR1, OUTPUT);
    pinMode(DIR2, OUTPUT);
  }
  for (int i = 0; i < 2; i++)
  {
    for (int j = 0; j < 2; j++)
    {
      myservo[i][j].attach(servo_pin[i][j]);
      delay(100);
    }
  }
}

void loop() {
  // put your main code here, to run repeatedly
  ctlDCMotor(1, 255);
  ctlDCMotor(2, 255);
  ctlStepMotor(360, 1);
  StepMotorStop();
  servoRotate();
  delay(1000);

  ctlDCMotor(1, -255);
  ctlDCMotor(2, -255);
  ctlStepMotor(-360, 1);
  StepMotorStop();
  servoRotate();
  delay(1000);
}

//Servo
void servoRotate()
{
  //4 servos rotate clockwise
  for (int i=0; i <= 180; i+=1)// goes from 0 to 180 degrees 

  {
    myservo[0][0].write(i);
    delay(1); //delay 1ms
    myservo[0][1].write(i);
    delay(1);
    myservo[1][0].write(i);
    delay(1);
    myservo[1][1].write(i);
    delay(1);
  }
  //4 servos rotate counterclockwise
  for(int i = 180; i>=0; i-=1)     // goes from 180 to 0 degrees
  {                                
    myservo[0][0].write(i);
    delay(1);
    myservo[0][1].write(i);
    delay(1);
    myservo[1][0].write(i);
    delay(1);
    myservo[1][1].write(i);
    delay(1);                     
  } 
}

void ctlStepMotor(int angle, char speeds )
{
  for (int j = 0; j < abs(angle) ; j++)
  {
    if (angle > 0)
    {
      for (int i = 0; i < 8; i++)
      {
        digitalWrite(A0, ((tab1[i] & 0x01) == 0x01 ? true : false));
        digitalWrite(A1, ((tab1[i] & 0x02) == 0x02 ? true : false));
        digitalWrite(A2, ((tab1[i] & 0x04) == 0x04 ? true : false));
        digitalWrite(A3, ((tab1[i] & 0x08) == 0x08 ? true : false));
        delay(speeds);
      }
    }
    else
    {
      for (int i = 0; i < 8 ; i++)
      {
        digitalWrite(A0, ((tab2[i] & 0x01) == 0x01 ? true : false));
        digitalWrite(A1, ((tab2[i] & 0x02) == 0x02 ? true : false));
        digitalWrite(A2, ((tab2[i] & 0x04) == 0x04 ? true : false));
        digitalWrite(A3, ((tab2[i] & 0x08) == 0x08 ? true : false));
        delay(speeds);
      }
    }
  }
}
void StepMotorStop()
{
  digitalWrite(A0, 0);
  digitalWrite(A1, 0);
  digitalWrite(A2, 0);
  digitalWrite(A3, 0);
}
void ctlDCMotor(byte MotorID, int speeds)
{
  if (MotorID == 1)
  {
    if (speeds > 0)
    {
      digitalWrite(DIR1, HIGH);
    }
    else
    {
      digitalWrite(DIR1, LOW);
    }
    if (abs(speeds) > 255)
    {
      speeds = 255;
    }
    analogWrite(PWM1, abs(speeds));
    //Serial.print("...........................................................left:");
    //Serial.println(abs(speeds));
  }
  else if (MotorID == 2)
  {
    if (speeds > 0)
    {
      digitalWrite(DIR2, HIGH);
    }
    else
    {
      digitalWrite(DIR2, LOW);
    }
    if (abs(speeds) > 255)
    {
      speeds = 255;
    }
    analogWrite(PWM2, abs(speeds));
    //Serial.print("...........................................................right:");
    //Serial.println(abs(speeds));
  }
}


