/*******************************************************
 * Name: Stepper Motor
 * Function: The Stepper Motor rotates clockwise
 * and then counterclockwise
 *******************************************************/
//Post technical questions on our FORUM. 
//Website: www.sunfounder.com

int pwm;

const char tab1[] =
{
  0x01, 0x03, 0x02, 0x06, 0x04, 0x0c, 0x08, 0x09
};
const char tab2[] =
{
  0x01, 0x09, 0x08, 0x0c, 0x04, 0x06, 0x02, 0x03
};

void setup() {
  pinMode(A0, OUTPUT);
  pinMode(A1, OUTPUT);
  pinMode(A2, OUTPUT);
  pinMode(A3, OUTPUT);
}

void loop() {

  ctlStepMotor(360, 1); //the motor rotates counterclockwise every 1ms
  StepMotorStop(); //stop the motor
  delay(1000); //delay 1s
  ctlStepMotor(-360, 1);//the motor rotates clockwise every 1ms
  StepMotorStop();//stop the motor
  delay(1000);//delay 1s
}

void ctlStepMotor(int angle, char speeds )//the stepper motor rotates from 0 to a certain angle
{
  for (int j = 0; j < abs(angle) ; j++)
  {
    if (angle > 0)
    {
      for (int i = 0; i < 8; i++)
      {
        digitalWrite(A0, ((tab1[i] & 0x01) == 0x01 ? true : false));
        digitalWrite(A1, ((tab1[i] & 0x02) == 0x02 ? true : false));
        digitalWrite(A2, ((tab1[i] & 0x04) == 0x04 ? true : false));
        digitalWrite(A3, ((tab1[i] & 0x08) == 0x08 ? true : false));
        delay(speeds);
      }
    }
    else
    {
      for (int i = 0; i < 8 ; i++)
      {
        digitalWrite(A0, ((tab2[i] & 0x01) == 0x01 ? true : false));
        digitalWrite(A1, ((tab2[i] & 0x02) == 0x02 ? true : false));
        digitalWrite(A2, ((tab2[i] & 0x04) == 0x04 ? true : false));
        digitalWrite(A3, ((tab2[i] & 0x08) == 0x08 ? true : false));
        delay(speeds);
      }
    }
  }
}
//stop the motor
void StepMotorStop()
{
  digitalWrite(A0, 0);
  digitalWrite(A1, 0);
  digitalWrite(A2, 0);
  digitalWrite(A3, 0);
}

